package MCVE;

use 5.006;
use strict;
use warnings;
use Carp;

require Exporter;
require DynaLoader;
use AutoLoader;

our @ISA = qw(Exporter DynaLoader);

# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.

# This allows declaration	use MCVE ':all';
# If you do not need this, moving things directly into @EXPORT or @EXPORT_OK
# will save memory.
our %EXPORT_TAGS = ( 'all' => [ qw(
	MCVE_AGENTID
	MCVE_AUTH
	MCVE_BAD
	MCVE_BANKID
	MCVE_CALL
	MCVE_CHAINID
	MCVE_CLIENTNUM
	MCVE_DENY
	MCVE_DONE
	MCVE_DUPL
	MCVE_ERROR
	MCVE_FAIL
	MCVE_FORCE
	MCVE_GOOD
	MCVE_INDCODE
	MCVE_MERCHCAT
	MCVE_MERCHID
	MCVE_MERCHLOC
	MCVE_MERNAME
	MCVE_NEW
	MCVE_OVERRIDE
	MCVE_PENDING
	MCVE_PKUP
	MCVE_PREAUTH
	MCVE_PROC
	MCVE_PWD
	MCVE_RETRY
	MCVE_RETURN
	MCVE_SALE
	MCVE_SERVICEPHONE
	MCVE_SETTLE
	MCVE_SETUP
	MCVE_STATECODE
	MCVE_STOREID
	MCVE_STREET
	MCVE_SUCCESS
	MCVE_TERMID
	MCVE_TIMEOUT
	MCVE_TIMEZONE
	MCVE_UNKNOWN
	MCVE_UNUSED
	MCVE_USER
	MCVE_VOID
	MCVE_ZIP
	MCVE_ZIPCODE
	MC_ACCOUNT
	MC_ACCT
	MC_ADMIN
	MC_ADMIN_BT
	MC_ADMIN_CFH
	MC_ADMIN_CTH
	MC_ADMIN_FORCESETTLE
	MC_ADMIN_GFT
	MC_ADMIN_GL
	MC_ADMIN_GUT
	MC_ADMIN_QC
	MC_ADMIN_RS
	MC_ADMIN_SETBATCHNUM
	MC_ADMIN_UB
	MC_AMOUNT
	MC_APPRCODE
	MC_AUDITTYPE
	MC_BATCH
	MC_BDATE
	MC_CLERKID
	MC_COMMENTS
	MC_CUSTOM
	MC_CV
	MC_EDATE
	MC_EXPDATE
	MC_FILE
	MC_PASSWORD
	MC_PTRANNUM
	MC_PWD
	MC_STATIONID
	MC_STREET
	MC_TRACKDATA
	MC_TRANTYPE
	MC_TRAN_ADDUSER
	MC_TRAN_ADMIN
	MC_TRAN_CHKPWD
	MC_TRAN_CHNGPWD
	MC_TRAN_DELUSER
	MC_TRAN_DISABLEUSER
	MC_TRAN_EDITUSER
	MC_TRAN_ENABLEUSER
	MC_TRAN_EXPORT
	MC_TRAN_FORCE
	MC_TRAN_GETUSERINFO
	MC_TRAN_IMPORT
	MC_TRAN_LISTSTATS
	MC_TRAN_LISTUSERS
	MC_TRAN_OVERRIDE
	MC_TRAN_PING
	MC_TRAN_PREAUTH
	MC_TRAN_PREAUTHCOMPLETE
	MC_TRAN_RETURN
	MC_TRAN_SALE
	MC_TRAN_SETTLE
	MC_TRAN_VOID
	MC_TTID
	MC_USER
	MC_USERNAME
	MC_USER_AGENTID
	MC_USER_BANKID
	MC_USER_CHAINID
	MC_USER_CLIENTNUM
	MC_USER_INDCODE
	MC_USER_MERCHCAT
	MC_USER_MERCHID
	MC_USER_MERCHLOC
	MC_USER_MERNAME
	MC_USER_PHONE
	MC_USER_PROC
	MC_USER_PWD
	MC_USER_STATECODE
	MC_USER_STOREID
	MC_USER_TERMID
	MC_USER_TIMEZONE
	MC_USER_USER
	MC_USER_ZIPCODE
	MC_ZIP
	MCVE_AddUser
	MCVE_AddUserArg
	MCVE_Bt
	MCVE_CheckStatus
	MCVE_Chkpwd
	MCVE_Chngpwd
	MCVE_CompleteAuthorizations
	MCVE_Connect
	MCVE_ConnectionError
	MCVE_DelUser
	MCVE_DeleteTrans
	MCVE_DeleteUserSetup
	MCVE_DestroyConn
	MCVE_DestroyEngine
	MCVE_DisableUser
	MCVE_EditUser
	MCVE_EnableUser
	MCVE_Export
	MCVE_Force
	MCVE_GetCell
	MCVE_GetCellByNum
	MCVE_GetCommaDelimited
	MCVE_GetHeader
	MCVE_GetUserArg
	MCVE_GetUserInfo
	MCVE_GetUserParam
	MCVE_Gft
	MCVE_Gl
	MCVE_Gut
	MCVE_Import
	MCVE_InitConn
	MCVE_InitEngine
	MCVE_InitUserSetup
	MCVE_IsCommaDelimited
	MCVE_ListStats
	MCVE_ListUsers
	MCVE_MaxConnTimeout
	MCVE_Monitor
	MCVE_NumColumns
	MCVE_NumRows
	MCVE_Override
	MCVE_ParseCommaDelimited
	MCVE_Ping
	MCVE_PreAuth
	MCVE_PreAuthCompletion
	MCVE_Qc
	MCVE_ResponseParam
	MCVE_Return
	MCVE_ReturnCode
	MCVE_ReturnStatus
	MCVE_Rs
	MCVE_Sale
	MCVE_SetBlocking
	MCVE_SetDropFile
	MCVE_SetIP
	MCVE_SetSSL
	MCVE_SetTimeout
	MCVE_Settle
	MCVE_TEXT_AVS
	MCVE_TEXT_CV
	MCVE_TEXT_Code
	MCVE_TransInQueue
	MCVE_TransNew
	MCVE_TransParam
	MCVE_TransSend
	MCVE_TransactionAVS
	MCVE_TransactionAuth
	MCVE_TransactionBatch
	MCVE_TransactionCV
	MCVE_TransactionID
	MCVE_TransactionItem
	MCVE_TransactionText
	MCVE_TransactionsSent
	MCVE_VerifyConnection
	MCVE_VerifySSLCert
	MCVE_Void
	MCVE_uwait
) ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );

our @EXPORT = qw(
	MCVE_AGENTID
	MCVE_AUTH
	MCVE_BAD
	MCVE_BANKID
	MCVE_CALL
	MCVE_CHAINID
	MCVE_CLIENTNUM
	MCVE_DENY
	MCVE_DONE
	MCVE_DUPL
	MCVE_ERROR
	MCVE_FAIL
	MCVE_FORCE
	MCVE_GOOD
	MCVE_INDCODE
	MCVE_MERCHCAT
	MCVE_MERCHID
	MCVE_MERCHLOC
	MCVE_MERNAME
	MCVE_NEW
	MCVE_OVERRIDE
	MCVE_PENDING
	MCVE_PKUP
	MCVE_PREAUTH
	MCVE_PROC
	MCVE_PWD
	MCVE_RETRY
	MCVE_RETURN
	MCVE_SALE
	MCVE_SERVICEPHONE
	MCVE_SETTLE
	MCVE_SETUP
	MCVE_STATECODE
	MCVE_STOREID
	MCVE_STREET
	MCVE_SUCCESS
	MCVE_TERMID
	MCVE_TIMEOUT
	MCVE_TIMEZONE
	MCVE_UNKNOWN
	MCVE_UNUSED
	MCVE_USER
	MCVE_VOID
	MCVE_ZIP
	MCVE_ZIPCODE
	MC_ACCOUNT
	MC_ACCT
	MC_ADMIN
	MC_ADMIN_BT
	MC_ADMIN_CFH
	MC_ADMIN_CTH
	MC_ADMIN_FORCESETTLE
	MC_ADMIN_GFT
	MC_ADMIN_GL
	MC_ADMIN_GUT
	MC_ADMIN_QC
	MC_ADMIN_RS
	MC_ADMIN_SETBATCHNUM
	MC_ADMIN_UB
	MC_AMOUNT
	MC_APPRCODE
	MC_AUDITTYPE
	MC_BATCH
	MC_BDATE
	MC_CLERKID
	MC_COMMENTS
	MC_CUSTOM
	MC_CV
	MC_EDATE
	MC_EXPDATE
	MC_FILE
	MC_PASSWORD
	MC_PTRANNUM
	MC_PWD
	MC_STATIONID
	MC_STREET
	MC_TRACKDATA
	MC_TRANTYPE
	MC_TRAN_ADDUSER
	MC_TRAN_ADMIN
	MC_TRAN_CHKPWD
	MC_TRAN_CHNGPWD
	MC_TRAN_DELUSER
	MC_TRAN_DISABLEUSER
	MC_TRAN_EDITUSER
	MC_TRAN_ENABLEUSER
	MC_TRAN_EXPORT
	MC_TRAN_FORCE
	MC_TRAN_GETUSERINFO
	MC_TRAN_IMPORT
	MC_TRAN_LISTSTATS
	MC_TRAN_LISTUSERS
	MC_TRAN_OVERRIDE
	MC_TRAN_PING
	MC_TRAN_PREAUTH
	MC_TRAN_PREAUTHCOMPLETE
	MC_TRAN_RETURN
	MC_TRAN_SALE
	MC_TRAN_SETTLE
	MC_TRAN_VOID
	MC_TTID
	MC_USER
	MC_USERNAME
	MC_USER_AGENTID
	MC_USER_BANKID
	MC_USER_CHAINID
	MC_USER_CLIENTNUM
	MC_USER_INDCODE
	MC_USER_MERCHCAT
	MC_USER_MERCHID
	MC_USER_MERCHLOC
	MC_USER_MERNAME
	MC_USER_PHONE
	MC_USER_PROC
	MC_USER_PWD
	MC_USER_STATECODE
	MC_USER_STOREID
	MC_USER_TERMID
	MC_USER_TIMEZONE
	MC_USER_USER
	MC_USER_ZIPCODE
	MC_ZIP
);
our $VERSION = '3.0';

sub AUTOLOAD {
    # This AUTOLOAD is used to 'autoload' constants from the constant()
    # XS function.  If a constant is not found then control is passed
    # to the AUTOLOAD in AutoLoader.

    my $constname;
    our $AUTOLOAD;
    ($constname = $AUTOLOAD) =~ s/.*:://;
    croak "& not defined" if $constname eq 'constant';
    my $val = constant($constname, @_ ? $_[0] : 0);
    if ($! != 0) {
	if ($! =~ /Invalid/ || $!{EINVAL}) {
	    $AutoLoader::AUTOLOAD = $AUTOLOAD;
	    goto &AutoLoader::AUTOLOAD;
	}
	else {
	    croak "Your vendor has not defined MCVE macro $constname";
	}
    }
    {
	no strict 'refs';
	    *$AUTOLOAD = sub { $val };
    }
    goto &$AUTOLOAD;
}

bootstrap MCVE $VERSION;

# Preloaded methods go here.

# Autoload methods go after =cut, and are processed by the autosplit program.

1;
__END__
# Below is stub documentation for your module. You better edit it!

=head1 NAME

MCVE - Perl extension for blah blah blah

=head1 SYNOPSIS

  use MCVE;
  blah blah blah

=head1 DESCRIPTION

Stub documentation for MCVE, created by h2xs. It looks like the
author of the extension was negligent enough to leave the stub
unedited.

Blah blah blah.

=head2 EXPORT

None by default.

=head2 Exportable constants

  MCVE_AGENTID
  MCVE_AUTH
  MCVE_BAD
  MCVE_BANKID
  MCVE_CALL
  MCVE_CHAINID
  MCVE_CLIENTNUM
  MCVE_DENY
  MCVE_DONE
  MCVE_DUPL
  MCVE_ERROR
  MCVE_FAIL
  MCVE_FORCE
  MCVE_GOOD
  MCVE_INDCODE
  MCVE_MERCHCAT
  MCVE_MERCHID
  MCVE_MERCHLOC
  MCVE_MERNAME
  MCVE_NEW
  MCVE_OVERRIDE
  MCVE_PENDING
  MCVE_PKUP
  MCVE_PREAUTH
  MCVE_PROC
  MCVE_PWD
  MCVE_RETRY
  MCVE_RETURN
  MCVE_SALE
  MCVE_SERVICEPHONE
  MCVE_SETTLE
  MCVE_SETUP
  MCVE_STATECODE
  MCVE_STOREID
  MCVE_STREET
  MCVE_SUCCESS
  MCVE_TERMID
  MCVE_TIMEOUT
  MCVE_TIMEZONE
  MCVE_UNKNOWN
  MCVE_UNUSED
  MCVE_USER
  MCVE_VOID
  MCVE_ZIP
  MCVE_ZIPCODE
  MC_ACCOUNT
  MC_ACCT
  MC_ADMIN
  MC_ADMIN_BT
  MC_ADMIN_CFH
  MC_ADMIN_CTH
  MC_ADMIN_FORCESETTLE
  MC_ADMIN_GFT
  MC_ADMIN_GL
  MC_ADMIN_GUT
  MC_ADMIN_QC
  MC_ADMIN_RS
  MC_ADMIN_SETBATCHNUM
  MC_ADMIN_UB
  MC_AMOUNT
  MC_APPRCODE
  MC_AUDITTYPE
  MC_BATCH
  MC_BDATE
  MC_CLERKID
  MC_COMMENTS
  MC_CUSTOM
  MC_CV
  MC_EDATE
  MC_EXPDATE
  MC_FILE
  MC_PASSWORD
  MC_PTRANNUM
  MC_PWD
  MC_STATIONID
  MC_STREET
  MC_TRACKDATA
  MC_TRANTYPE
  MC_TRAN_ADDUSER
  MC_TRAN_ADMIN
  MC_TRAN_CHKPWD
  MC_TRAN_CHNGPWD
  MC_TRAN_DELUSER
  MC_TRAN_DISABLEUSER
  MC_TRAN_EDITUSER
  MC_TRAN_ENABLEUSER
  MC_TRAN_EXPORT
  MC_TRAN_FORCE
  MC_TRAN_GETUSERINFO
  MC_TRAN_IMPORT
  MC_TRAN_LISTSTATS
  MC_TRAN_LISTUSERS
  MC_TRAN_OVERRIDE
  MC_TRAN_PING
  MC_TRAN_PREAUTH
  MC_TRAN_PREAUTHCOMPLETE
  MC_TRAN_RETURN
  MC_TRAN_SALE
  MC_TRAN_SETTLE
  MC_TRAN_VOID
  MC_TTID
  MC_USER
  MC_USERNAME
  MC_USER_AGENTID
  MC_USER_BANKID
  MC_USER_CHAINID
  MC_USER_CLIENTNUM
  MC_USER_INDCODE
  MC_USER_MERCHCAT
  MC_USER_MERCHID
  MC_USER_MERCHLOC
  MC_USER_MERNAME
  MC_USER_PHONE
  MC_USER_PROC
  MC_USER_PWD
  MC_USER_STATECODE
  MC_USER_STOREID
  MC_USER_TERMID
  MC_USER_TIMEZONE
  MC_USER_USER
  MC_USER_ZIPCODE
  MC_ZIP

=head2 Exportable functions

  long MCVE_AddUser(MCVE_CONN *myconn, char *adminpwd, MCVE_UserSetup *setup)
  int MCVE_AddUserArg(MCVE_UserSetup *setup, int argtype, char *argval)
  long MCVE_Bt(MCVE_CONN *myconn, char *username, char *password)
  int MCVE_CheckStatus(MCVE_CONN *myconn, long trans)
  long MCVE_Chkpwd(MCVE_CONN *myconn, char *username, char *password)
  long MCVE_Chngpwd(MCVE_CONN *myconn, char *adminpwd, char *newpassword)
  long MCVE_CompleteAuthorizations(MCVE_CONN *myconn, long **listings)
  int MCVE_Connect(MCVE_CONN *myconn)
  char *MCVE_ConnectionError(MCVE_CONN *myconn)
  long MCVE_DelUser(MCVE_CONN *myconn, char *adminpwd, char *user)
  void MCVE_DeleteTrans(MCVE_CONN *myconn, long identifier)
  void MCVE_DeleteUserSetup(MCVE_UserSetup *setup)
  void MCVE_DestroyConn(MCVE_CONN *myconn)
  void MCVE_DestroyEngine()
  long MCVE_DisableUser(MCVE_CONN *myconn, char *adminpwd, char *user)
  long MCVE_EditUser(MCVE_CONN *myconn, char *adminpwd, MCVE_UserSetup *setup)
  long MCVE_EnableUser(MCVE_CONN *myconn, char *adminpwd, char *user)
  long MCVE_Export(MCVE_CONN *myconn, char *adminpwd, char *filename)
  long MCVE_Force(MCVE_CONN *myconn, char *username, char *password, char *trackdata, char *account, char *expdate, double amount,
                char *authcode, char *comments, char *clerkid, char *stationid, long ptrannum)
  char *MCVE_GetCell(MCVE_CONN *myconn, long identifier, char *column, long row)
  char *MCVE_GetCellByNum(MCVE_CONN *myconn, long identifier, int column, long row)
  char *MCVE_GetCommaDelimited(MCVE_CONN *myconn, long identifier)
  char *MCVE_GetHeader(MCVE_CONN *myconn, long identifier, int column_num)
  char *MCVE_GetUserArg(MCVE_UserSetup *usersetup, int argtype)
  long MCVE_GetUserInfo(MCVE_CONN *myconn, char *adminpwd, char *user)
  char *MCVE_GetUserParam(MCVE_CONN *myconn, long identifier, int key)
  long MCVE_Gft(MCVE_CONN *myconn, char *username, char *password, int type, char *acct, char *clerkid, char *stationid, char *comments,
                              double ptrannum, char *bdate, char *edate)
  long MCVE_Gl(MCVE_CONN *myconn, char *username, char *password, int type, char *acct, char *batch, char *clerkid, char *stationid, char *comments,
                              double ptrannum, char *bdate, char *edate)
  long MCVE_Gut(MCVE_CONN *myconn, char *username, char *password, int type, char *acct, char *clerkid, char *stationid, char *comments,
                              double ptrannum, char *bdate, char *edate)
  long MCVE_Import(MCVE_CONN *myconn, char *adminpwd, char *filename)
  void MCVE_InitConn(MCVE_CONN *myconn)
  int MCVE_InitEngine(char *location)
  void MCVE_InitUserSetup(MCVE_UserSetup *setup)
  int MCVE_IsCommaDelimited(MCVE_CONN *myconn, long identifier)
  long MCVE_ListStats(MCVE_CONN *myconn, char *adminpwd)
  long MCVE_ListUsers(MCVE_CONN *myconn, char *adminpwd)
  void MCVE_MaxConnTimeout(MCVE_CONN *myconn, int maxtime)
  int MCVE_Monitor(MCVE_CONN *myconn)
  int MCVE_NumColumns(MCVE_CONN *myconn, long identifier)
  long MCVE_NumRows(MCVE_CONN *myconn, long identifier)
  long MCVE_Override(MCVE_CONN *myconn, char *username, char *password, char *trackdata, char *account, char *expdate, double amount,
                                     char *street, char *zip, char *cv, char *comments, char *clerkid, char *stationid, long ptrannum)
  int MCVE_ParseCommaDelimited(MCVE_CONN *myconn, long identifier)
  long MCVE_Ping(MCVE_CONN *myconn)
  long MCVE_PreAuth(MCVE_CONN *myconn, char *username, char *password, char *trackdata, char *account, char *expdate, double amount,
                                     char *street, char *zip, char *cv, char *comments, char *clerkid, char *stationid, long ptrannum)
  long MCVE_PreAuthCompletion(MCVE_CONN *myconn, char *username, char *password, double finalamount, MCVE_int64 ttid, long ptrannum)
  long MCVE_Qc(MCVE_CONN *myconn, char *username, char *password, char *clerkid, char *stationid, char *comments, double ptrannum)
  char *MCVE_ResponseParam(MCVE_CONN *myconn, long identifier, char *key)
  long MCVE_Return(MCVE_CONN *myconn, char *username, char *password, char *trackdata, char *account, char *expdate, double amount,
                                     char *comments, char *clerkid, char *stationid, long ptrannum)
  int MCVE_ReturnCode(MCVE_CONN *myconn, long identifier)
  int MCVE_ReturnStatus(MCVE_CONN *myconn, long identifier)
  long MCVE_Rs(MCVE_CONN *myconn, char *username, char *password, char *stationid)
  long MCVE_Sale(MCVE_CONN *myconn, char *username, char *password, char *trackdata, char *account, char *expdate, double amount,
                               char *street, char *zip, char *cv, char *comments, char *clerkid, char *stationid, long ptrannum)
  int MCVE_SetBlocking(MCVE_CONN *myconn, int tf)
  int MCVE_SetDropFile(MCVE_CONN *myconn, char *df_location)
  int MCVE_SetIP(MCVE_CONN *myconn, char *host, unsigned long port)
  int MCVE_SetSSL(MCVE_CONN *myconn, char *host, unsigned long port)
  int MCVE_SetTimeout(MCVE_CONN *myconn, long timeout)
  long MCVE_Settle(MCVE_CONN *myconn, char *username, char *password, char *batch)
  char *MCVE_TEXT_AVS(int code)
  char *MCVE_TEXT_CV(int code)
  char *MCVE_TEXT_Code(int code)
  long MCVE_TransInQueue(MCVE_CONN *myconn)
  long MCVE_TransNew(MCVE_CONN *myconn)
  int MCVE_TransParam(MCVE_CONN *myconn, long identifier, int key, ...)
  int MCVE_TransSend(MCVE_CONN *myconn, long identifier)
  int MCVE_TransactionAVS(MCVE_CONN *myconn, long identifier)
  char *MCVE_TransactionAuth(MCVE_CONN *myconn, long identifier)
  long MCVE_TransactionBatch(MCVE_CONN *myconn, long identifier)
  int MCVE_TransactionCV(MCVE_CONN *myconn, long identifier)
  MCVE_int64 MCVE_TransactionID(MCVE_CONN *myconn, long identifier)
  long MCVE_TransactionItem(MCVE_CONN *myconn, long identifier)
  char *MCVE_TransactionText(MCVE_CONN *myconn, long identifier)
  int MCVE_TransactionsSent(MCVE_CONN *myconn)
  void MCVE_VerifyConnection(MCVE_CONN *myconn, int tf)
  void MCVE_VerifySSLCert(MCVE_CONN *myconn, int tf)
  long MCVE_Void(MCVE_CONN *myconn, char *username, char *password, MCVE_int64 ttid, long ptrannum)
  int MCVE_uwait(unsigned long length)


=head1 AUTHOR

A. U. Thor, E<lt>a.u.thor@a.galaxy.far.far.awayE<gt>

=head1 SEE ALSO

L<perl>.

=cut
