
use MCVE;

$host = "testbox.mcve.com";
$sslport = 8444;
$regport = 8333;
# METHODs -- 1) IP  2) SSL
$method=1;

print("LIBMCVE 3.0 DEMO\r\n\r\n");
# Location for CA certificates to verify server certificate
MCVE::MCVE_InitEngine("/var/mcve/CAfile.pem");

$conn=MCVE::MCVE_InitConn();
if ($method == 1) {
  MCVE::MCVE_SetIP($conn, $host, $regport);
} elsif ($method == 2) {
  MCVE::MCVE_SetSSL($conn, $host, $sslport);
}
MCVE::MCVE_SetBlocking($conn, 1);
MCVE::MCVE_SetTimeout($conn, 30);

print("Connecting ...");
if (!MCVE::MCVE_Connect($conn)) {
  $error=MCVE_ConnectionError($conn);
  print("Connection failed: $error");
  MCVE::MCVE_DestroyConn($conn);
  MCVE::MCVE_DestroyEngine();
  exit();
}
print("success!\r\n\r\n");

print("Sending transaction:\r\n");
$identifier=MCVE::MCVE_TransNew($conn);
MCVE::MCVE_TransParam($conn, $identifier, MCVE::MC_USERNAME(), "vitale");
MCVE::MCVE_TransParam($conn, $identifier, MCVE::MC_PASSWORD(), "test");
MCVE::MCVE_TransParam($conn, $identifier, MCVE::MC_TRANTYPE(), MCVE::MC_TRAN_SALE());
MCVE::MCVE_TransParam($conn, $identifier, MCVE::MC_ACCOUNT(), "4012888888881");
MCVE::MCVE_TransParam($conn, $identifier, MCVE::MC_EXPDATE(), "0512");
MCVE::MCVE_TransParam($conn, $identifier, MCVE::MC_AMOUNT(), 65.65);
MCVE::MCVE_TransParam($conn, $identifier, MCVE::MC_COMMENTS(), "NEW MCVE_PERL_3 TEST");

if (!MCVE::MCVE_TransSend($conn, $identifier)) {
  print("Failure structuring/sending transaction, probably improperly structured");
  MCVE::MCVE_DestroyConn($conn);
  MCVE::MCVE_DestroyEngine();
  exit();
}

$status=MCVE::MCVE_ReturnStatus($conn, $identifier);

if ($status == MCVE::MCVE_SUCCESS()) {    # Was it good, you may also check agains MCVE::MCVE_FAIL()
  print("Transaction Authorized!!\r\n");
} else {
  print("Transaction Denied!\r\n");
}

$code=MCVE::MCVE_TEXT_Code(MCVE::MCVE_ReturnCode($conn, $identifier));
print("Code: $code\r\n");

$text=MCVE::MCVE_TransactionText($conn, $identifier);
print("Text: $text\r\n");

$id=MCVE::MCVE_TransactionID($conn, $identifier);
print("TTID: $id\r\n");

$avs=MCVE::MCVE_TEXT_AVS(MCVE::MCVE_TransactionAVS($conn, $identifier));
print("AVS: $avs\r\n");

$cv=MCVE::MCVE_TEXT_CV(MCVE::MCVE_TransactionCV($conn, $identifier));
print("CV: $cv\r\n");

$raw_code=MCVE::MCVE_ResponseParam($conn, $identifier, "raw_code");
print("raw_code: $raw_code\r\n");

$raw_avs=MCVE::MCVE_ResponseParam($conn, $identifier, "raw_avs");
print("raw_avs: $raw_avs\r\n");

$raw_cv=MCVE::MCVE_ResponseParam($conn, $identifier, "raw_cv");
print("raw_cv: $raw_cv\r\n");

if ($status == MCVE::MCVE_SUCCESS()) {
  $auth=MCVE::MCVE_TransactionAuth($conn, $identifier);
  print("auth: $auth\r\n");
}


# OTHER FUNCTIONS OF INTEREST
# $item=MCVE::MCVE_TransactionItem($conn, $identifier);  -- Item number in Batch
# $batch=MCVE::MCVE_TransactionBatch($conn, $identifier); -- Batch Number for transaction
# $ttid=MCVE::MCVE_TransactionID($conn, $identifier);  -- Internal MCVE Transaction ID.  Use this number or your $ptrannum to VOID or FORCE transactions


print("\r\nclosing connection and cleaning up\r\n");
MCVE::MCVE_DestroyConn($conn);
MCVE::MCVE_DestroyEngine();

